searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"Mix.Tasks.Pot.Build.html","title":"mix pot.build","type":"task"},{"doc":"Takes in the runtime [\"docker\" | \"podman\" | \"nerdctl\"], the pot name\npassed in as arguments or `:no_name`. It will check to see\nif there is an exisiting Dockerfile generated by pot\nand if not run the tast `pot.new` with default arguments.\nThen it will run the container runtime command in the following\nformat to generate the image.\n`  build -f   --build-arg MIX_ENV=dev -t   --label pot_ =pot`","ref":"Mix.Tasks.Pot.Build.html#build_image/1","title":"Mix.Tasks.Pot.Build.build_image/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Pot.Clean.html","title":"mix pot.clean","type":"task"},{"doc":"Breaks out the process arguments and runs different cleanup.\ntasks depending on whats been passed in.\n- `--files`: It will remove all Docker files generated by Pots.\n- `--images`: It will remove all container images created by Pots.\n- `--containers`: It will remove all containers created by Pots.","ref":"Mix.Tasks.Pot.Clean.html#process_arg/1","title":"Mix.Tasks.Pot.Clean.process_arg/1","type":"function"},{"doc":"Remove all docker files created by Pots. This will\nonly affect files that start with `Docker` and end\nwith `.pot`","ref":"Mix.Tasks.Pot.Clean.html#remove_docker_files/0","title":"Mix.Tasks.Pot.Clean.remove_docker_files/0","type":"function"},{"doc":"Remove all container images created by Pots. This will\nonly affect images with the label `pot_ `","ref":"Mix.Tasks.Pot.Clean.html#remove_docker_images/0","title":"Mix.Tasks.Pot.Clean.remove_docker_images/0","type":"function"},{"doc":"This will run all cleanup functions. Note: it will stop all\ncontainers before attempting to remove the images. Excludes\nrunning `remove_docker_files/0` since it may contain\nchanges the user wants to keep.\n- `remove_docker_files/0`\n- `stop_docker_containers/0`\n- `remove_docker_images/0`","ref":"Mix.Tasks.Pot.Clean.html#run_all/0","title":"Mix.Tasks.Pot.Clean.run_all/0","type":"function"},{"doc":"Stop all running containers created by Pots. This will\nonly affect containers with the label `pot_ `","ref":"Mix.Tasks.Pot.Clean.html#stop_docker_containers/0","title":"Mix.Tasks.Pot.Clean.stop_docker_containers/0","type":"function"},{"doc":"","ref":"Mix.Tasks.Pot.Info.html","title":"mix pot.info","type":"task"},{"doc":"","ref":"Mix.Tasks.Pot.New.html","title":"mix pot.new","type":"task"},{"doc":"","ref":"Mix.Tasks.Pot.Run.html","title":"mix pot.run","type":"task"},{"doc":"Utils for running Pot tasks. Most of the logic of Pot tasks are contained here.","ref":"PotUtils.html","title":"PotUtils","type":"module"},{"doc":"Get the application name. Thils is either the value of `:app` in the\napplication configuration or the return value of `Application.get_all_env(__MODULE__)`","ref":"PotUtils.html#app_name/0","title":"PotUtils.app_name/0","type":"function"},{"doc":"Returns a list of `Dockerfiles` for Pot. It looks for files that start\nwith `Docker` and end with `.pot`.","ref":"PotUtils.html#get_all_docker_files/0","title":"PotUtils.get_all_docker_files/0","type":"function"},{"doc":"Trys to run the program `docker`. If it errors, it will raise\nand error because no suitable container runtime can be found.","ref":"PotUtils.html#get_docker/0","title":"PotUtils.get_docker/0","type":"function"},{"doc":"Returns a list of all docker containers, filtered by the label of\n`pot_ ` in JSON format. If none are returned, it returns\nan empty list. Uses the command in the format of\n`  container ls --filter lable=pot_  --format {{json}}`","ref":"PotUtils.html#get_docker_containers/0","title":"PotUtils.get_docker_containers/0","type":"function"},{"doc":"Gets the name of the Dockerfile. If `:no_name` is passed in then it\nsimply returns `Dockerfile.pot`. If any other string is passed to it, it will\nreturn `Docerfile. .pot`.","ref":"PotUtils.html#get_docker_file_for_pot/1","title":"PotUtils.get_docker_file_for_pot/1","type":"function"},{"doc":"iex> PotUtils.get_docker_file_for_pot(:no_name)\n  Dockerfile.pot\n  iex> PotUtils.get_docker_file_for_pot(\"my_project\")\n  Dockerfile.my_project.pot","ref":"PotUtils.html#get_docker_file_for_pot/1-example","title":"Example - PotUtils.get_docker_file_for_pot/1","type":"function"},{"doc":"Returns a list of all docker images, filtered by the label of\n`pot_ ` in JSON format. If none are returned, it returns\nan empty list. Uses the command in the format of\n`  images --filter lable=pot_  --format {{json}}`","ref":"PotUtils.html#get_docker_images/0","title":"PotUtils.get_docker_images/0","type":"function"},{"doc":"Trys to run the program `nerdctl`. If it errors, it will move\non to try the next runtime `podman`.","ref":"PotUtils.html#get_nerdctl/0","title":"PotUtils.get_nerdctl/0","type":"function"},{"doc":"Trys to run the program `podman`. If it errors, it will move\non to try the next runtime `docker`.","ref":"PotUtils.html#get_podman/0","title":"PotUtils.get_podman/0","type":"function"},{"doc":"Get the current container run time to use. The return values can\nbe the strings of \"docker\", \"podman\", or \"nerdctl\". Currently\ndoes not allow for choosing your runtime, this is to be added later.","ref":"PotUtils.html#get_runtime/0","title":"PotUtils.get_runtime/0","type":"function"},{"doc":"Similar to `PotUtils.get_docker_containers/0`, it filters all containers on the label of\n`pot_ ` and simply prints the output of the command. Uses the command\nin the format of\n`  container ls --filter lable=pot_ `","ref":"PotUtils.html#print_containers/0","title":"PotUtils.print_containers/0","type":"function"},{"doc":"Similar to `PotUtils.get_docker_images/0`, it filters all images on the label of\n`pot_ ` and simply prints the output of the command. Uses the command\nin the format of\n`  images --filter lable=pot_ `","ref":"PotUtils.html#print_images/0","title":"PotUtils.print_images/0","type":"function"},{"doc":"Remove all container images created by Pot. This will only touch images labled appropriately\nby pot. This runs the command `  image rm  `","ref":"PotUtils.html#remove_image/1","title":"PotUtils.remove_image/1","type":"function"},{"doc":"Takes in the command to be run using the runtime returned from `PotUtils.get_runtime/0`.\nSplits the `cmd` up and passes it to `System.cmd`.","ref":"PotUtils.html#runtime_cmd/1","title":"PotUtils.runtime_cmd/1","type":"function"},{"doc":"Takes in the command to be run using the runtime returned from `PotUtils.get_runtime/0`.\nSplits the `cmd` up and passes it to `System.cmd`. This one returns the output from\nthe command run unlike `runtime_cmd/1`","ref":"PotUtils.html#runtime_cmd_output/1","title":"PotUtils.runtime_cmd_output/1","type":"function"},{"doc":"Stop all running containers created by Pot. This should\nalso remove them as all containers are started with the\noptions `--rm` which means to remove them once stopped.\nUses the command in the format of `  stop <container-id`","ref":"PotUtils.html#stop_container/1","title":"PotUtils.stop_container/1","type":"function"},{"doc":"# Pots\n\nSome wrapper functionality around generating Dockerfiles and managing them\nfor an elixir project. This project is still very much in the early stages\nso use at your own risk. \n\n**ATTENTION**: While this has been written to support `docker`, `podman`, and `nerdctl`\nit has only been tested with `podman` currently. Test the other two is still a\nTODO.","ref":"readme.html","title":"Pots","type":"extras"},{"doc":"- [ ] Generate some kind of configuration for Pots.\n- [ ] Allow selection of container runtime in config.\n- [ ] Provide better defaults for the Dockerfile.\n- [ ] Config options for how the containers are run. (e.g. a list of flags such as `--rm`, `-it`, ect.)\n- [ ] Test with both `docker` and `nerdctl`","ref":"readme.html#todo","title":"TODO - Pots","type":"extras"},{"doc":"You will need one of the following container run times;\n- [Docker](https://www.docker.com/get-started/)\n- [Podman](https://podman.io/)\n- [Nerdctl (containerd)](https://github.com/containerd/nerdctl)","ref":"readme.html#requirements","title":"Requirements - Pots","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `pots` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:pots, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation","title":"Installation - Pots","type":"extras"},{"doc":"`mix pot.new`\n> This task will generate a Dockerfile to be used by Pots. This\n> is just a regular Dockerfile so you don't have to run it\n> specifically using Pots.\n\n`mix pot.build`\n> This will build the Dockerfile generated from `mix pot.new`. If\n> you haven't generated a file yet it will run `mix pot.new`\n\n`mix pot.run`\n> This will start the container. It defaults to `-d` (detached mode).\n> You may also pass in `-i` for interactive mode. Be aware, all containers\n> are started with `--rm` so they will be discarded once shut down.\n\n`mix pot.clean`\n> This will remove files, images, and containers created by Pots.\n> You may pass `--files` to remove Dockerfiles, `--images` to remove\n> images, and `--containers` to stop (and remove) containers. \n\n`mix pot.info`\n> This will simply output information about the files/images/containers\n> generated by pots using your container runtime.","ref":"readme.html#tasks","title":"Tasks - Pots","type":"extras"},{"doc":"MIT License\n\nCopyright (c) [year] [fullname]\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"- Bufix\n  - Fixed an issue when logging status of `mix pot.clean` was referencing\n  a possible `nil` key in map\n  - Removed having the `--file` option as default in `mix pot.clean`","ref":"changelog.html#v0-1-2-2023-10-28","title":"v0.1.2 (2023-10-28) - Changelog","type":"extras"},{"doc":"- Bufix\n  - Added a runtime_cmd_output command because runtime_cmd only returned an iostruct","ref":"changelog.html#v0-1-1-2023-10-28","title":"v0.1.1 (2023-10-28) - Changelog","type":"extras"},{"doc":"- Enhancements\n  - First version created\n  - Support for docker, podman, and nerdctl","ref":"changelog.html#v0-1-0-2023-10-28","title":"v0.1.0 (2023-10-28) - Changelog","type":"extras"}]}